﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace GridViewRowDetailsSync
{
	/// <summary>
	/// MainWindow.xaml에 대한 상호 작용 논리
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			DataContext = new MainWindowViewModel();
		}
	}


	public class MainWindowViewModel : ViewModelBase
	{
		public ObservableCollection<TestModel> Test { get; set; }
		public MainWindowViewModel()
		{
			var sample = new ObservableCollection<TestModel>
			{
				new TestModel { GpA = "a", GpB = "a", GpC ="a", Name1 = "1", Name2 = "A", Name3 = "", Nic1 = "A", Nic2 = "", Nic3 = "1"},
				new TestModel { GpA = "a", GpB = "a", GpC ="a", Name1 = "2", Name2 = "B", Name3 = "", Nic1 = "B", Nic2 = "", Nic3 = "2"},
				new TestModel { GpA = "a", GpB = "b", GpC ="b", Name1 = "3", Name2 = "C", Name3 = "", Nic1 = "C", Nic2 = "", Nic3 = "3"},
				new TestModel { GpA = "b", GpB = "a", GpC ="a", Name1 = "4", Name2 = "D", Name3 = "", Nic1 = "D", Nic2 = "", Nic3 = "4"},
				new TestModel { GpA = "b", GpB = "b", GpC ="b", Name1 = "5", Name2 = "E", Name3 = "", Nic1 = "E", Nic2 = "", Nic3 = "5"},
				new TestModel { GpA = "a", GpB = "a", GpC ="b", Name1 = "6", Name2 = "F", Name3 = "", Nic1 = "F", Nic2 = "", Nic3 = "6"},
				new TestModel { GpA = "a", GpB = "b", GpC ="b", Name1 = "7", Name2 = "G", Name3 = "", Nic1 = "G", Nic2 = "", Nic3 = "7"},
				new TestModel { GpA = "b", GpB = "a", GpC ="a", Name1 = "8", Name2 = "F", Name3 = "", Nic1 = "F", Nic2 = "", Nic3 = "8"},
				new TestModel { GpA = "b", GpB = "b", GpC ="a", Name1 = "9", Name2 = "I", Name3 = "", Nic1 = "I", Nic2 = "", Nic3 = "9"},
				new TestModel { GpA = "a", GpB = "a", GpC ="a", Name1 = "0", Name2 = "J", Name3 = "", Nic1 = "J", Nic2 = "", Nic3 = "0"},
			};

			var result = sample.GroupBy(x => new
			{
				x.GpA,
				x.GpB,
				x.GpC,
			}).Select(x => new TestModel
			{
				GpA = x.Key.GpA,
				GpB = x.Key.GpB,
				GpC = x.Key.GpC,

				Children = new ObservableCollection<TestModel>(x),
			});

			Test = new ObservableCollection<TestModel>(result);
		}



		/// <summary>
		/// Show/Hide Column Button Event
		/// </summary>
		public ICommand OnClickCommand => new DelegateCommand(obj =>
		{
			var columnCollection = obj as Telerik.Windows.Controls.GridViewColumnCollection;
			if (columnCollection != null && columnCollection.Count > 0)
			{
				var window = new AvailableColumns();
				window.xParameters.ItemsSource = columnCollection.OfType<GridViewBoundColumnBase>();
				window.Show();
			}
		});
	}

}
